package com.sample;

import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;
import org.junit.Test;

import org.kie.api.KieServices;
import org.kie.api.runtime.KieContainer;
import org.kie.api.runtime.KieSession;

import com.sample.Fact;


public class accumulateBigDecimalTest {
	
	int NUM = 5;
	
//	@Test
//	public void longTest() {
//		
//        try {
//        	
// //          System.setProperty("drools.propertySpecific","ALLOWED");
//
//            // load up the knowledge base
//	        KieServices ks = KieServices.Factory.get();
//    	    KieContainer kContainer = ks.getKieClasspathContainer();
//        	KieSession kSession = kContainer.newKieSession();
//        	
//			for(int i = 0;i < NUM; i++) {
//				Fact fact = new Fact(100 + i*i*10);
//		        System.out.println(fact);
//		        kSession.insert(fact);
//			}
//	
//          kSession.getAgenda().getAgendaGroup("long").setFocus();
//
//			System.out.println("################### fireAllRules(long): "+System.getProperty("drools.propertySpecific","ALWAYS"));
//            int cnt = kSession.fireAllRules();
//			System.out.println("################### rules fired : "+cnt);
//			assertThat(cnt,is(NUM-1));
//
//        } catch (Throwable t) {
//            t.printStackTrace();
//        }
//
//	}
	@Test
	public void bigDecimalTest() {
		
    try {
    	
        System.setProperty("drools.propertySpecific","ALLOWED");


        // load up the knowledge base
        KieServices ks = KieServices.Factory.get();
	    KieContainer kContainer = ks.getKieClasspathContainer();
    	KieSession kSession = kContainer.newKieSession();
    	
    	for(int i = 0;i < NUM; i++) {
    		Fact fact = new Fact( 100 + i*i*10);
            System.out.println(fact);
            kSession.insert(fact);
    	}
    	
        kSession.getAgenda().getAgendaGroup("BigDecimal").setFocus();

		System.out.println("################### fireAllRules(BigDecimal) : "+System.getProperty("drools.propertySpecific","ALWAYS"));
        int cnt = kSession.fireAllRules();
		System.out.println("################### rules fired : "+cnt);		
		assertThat(cnt,is(NUM-1));
		
    } catch (Throwable t) {
        t.printStackTrace();
    }

	}
	

}
